import Flutter
import UIKit

public class FlCameraPlugin: NSObject, FlutterPlugin {
    var flCameraChannel: FlutterMethodChannel?
    var flCameraMethodCall: FlCameraMethodCall?

    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "fl.camera", binaryMessenger: registrar.messenger())
        let instance = FlCameraPlugin(registrar, channel)
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

    init(_ _registrar: FlutterPluginRegistrar, _ _channel: FlutterMethodChannel) {
        flCameraChannel = _channel
        flCameraMethodCall = FlCameraMethodCall(_registrar)
        super.init()
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        flCameraMethodCall?.handle(call: call, result: result)
    }

    public func detachFromEngine(for registrar: FlutterPluginRegistrar) {
        flCameraChannel?.setMethodCallHandler(nil)
        flCameraChannel = nil
        flCameraMethodCall?.dispose()
    }
}
